from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from Globals import InitializeClass
from Globals import DTMLFile


class ScheduleList(SimpleItem):
	""" Schedule list object, contains information about all schedules in ZODB """

	manage_options = (
		{'label':'Schedule list', 'action':'manageScheduleListForm'},
		{'label':'Security', 'action':'manage_access'},
		{'label':'Undo', 'action':'manage_UndoForm'},
		{'label':'Event catalog', 'action':'manageCatalogForm'},
	)

	security = ClassSecurityInfo()

	manageScheduleListForm = DTMLFile('dtml/manageScheduleList', globals())

	def __init__(self, id='ScheduleList', title="Schedule list"):
		self.id = id
		self.title = title
		self._schedulePathList = []
		self._p_changed = 1

	def registrySchedule(self, schedulePath):
		if not schedulePath in self._schedulePathList:
			self._schedulePathList.append(schedulePath)
			self._p_changed = 1
			

	def unregistrySchedule(self, schedulePath):
		if schedulePath in self._schedulePathList:
			self._schedulePathList.remove(schedulePath)
			self._p_changed = 1
                        get_transaction().commit()


	security.declarePublic('getList')
	def getList(self):
		return self._schedulePathList
	

	security.declarePublic('getUrlList')
	def getUrlList(self):
		return self._schedulePathList
#		urlList = []
#		for oid in self._scheduleOidList:
#			urlList.append( '/'.join(self._p_jar[oid].getPhysicalPath()))
#		return urlList


def createScheduleList(self, REQUEST={}):
	""" Create a new Scheldule """
	scheduleList = ScheduleList()
	self._setObject(scheduleList.id, scheduleList)

	
	if REQUEST:
		REQUEST['RESPONSE'].redirect( self.DestinationURL() + '/manage_main' )


def initialize(context):
	context.registerClass(
   	ScheduleList,
      permission = 'Add ScheduleList',
      constructors = (createScheduleList, ))


InitializeClass(ScheduleList)
