""" 
$Id: ScheduleTool.py,v 1.3 2002/12/26 14:07:40 asadim Exp $
"""
__version__='$Revision: 1.3 $'[11:-2]

import Globals

from Acquisition import aq_inner, aq_parent

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.Expression import Expression
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName
from Products.NauScheduler.Schedule import Schedule

class ScheduleTool(Schedule, ActionProviderBase ):
    def __init__(self):
    	Schedule.__init__(self, id='portal_scheduler')


    meta_type = 'NauSite Schedule Tool'
    _actions = [	ActionInformation(id='log'
                                , title='Logs'
                                , action=Expression(
                text='string: ${portal_url}/portal_scheduler/skins_logs')
                                , permissions=('Manage portal',)
                                , category='global'
                                , visible=1
                                 ),
						ActionInformation(id='manage'
                                , title='Manage schedule'
                                , action=Expression(
                text='string: ${portal_url}/portal_scheduler/skins_manageSchedule')
                                , permissions=('Manage portal',)
                                , category='global'
                                , visible=1
                                 ),]

    security = ClassSecurityInfo()

    manage_options = (ActionProviderBase.manage_options +
                     ({ 'label' : 'Overview', 'action' : 'manage_overview' }
                     , 
                     ) + Schedule.manage_options)

    #
    #   ZMI methods
    #
    security.declareProtected( CMFCorePermissions.ManagePortal
                             , 'manage_overview' )
    #manage_overview = DTMLFile( 'explainScheduleTool', _dtmldir )

    #
    #   'portal_scheduler' interface methods
    #

    security.declarePrivate('listActions')
    def listActions(self, info=None):
        """
        Return available actions via tool.
        """
        return self._actions

