from zLOG import LOG, TRACE, DEBUG, INFO, ERROR
from DateTime import DateTime
import Schedule
import ScheduleList
import threading
import thread

_started = 0
_threads = []

def startThreads( *args ):
    while _threads:
	t = _threads.pop(0)
	try:
	    if t.getName().find('NauScheduler') == 0 and not t.isAlive():
		LOG( 'NauScheduler.startThreads', TRACE, 'starting thread %s' % t.getName() )
		t.start()
	except:
	    pass
    _started = 1

def asyncore_loop( timeout=30.0, use_poll=0, map=None ):
    startThreads()
    asyncore.loop = asyncore._nau_loop
    del asyncore._nau_loop
    asyncore.loop( timeout, use_poll, map )

if not _started:
    try:
	from ThreadedAsync import register_loop_callback
	LOG( 'NauScheduler.__init__', TRACE, 'Registering callback' )
	register_loop_callback( startThreads )

    except ImportError:
	from ZServer import asyncore
	if not hasattr( asyncore, '_nau_loop' ):
	    LOG( 'NauScheduler.__init__', INFO, 'Patching asyncore' )
	    asyncore._nau_loop = asyncore.loop
	    asyncore.loop = asyncore_loop


def initialize(context):
	for module in [
		Schedule,
		ScheduleList,
			]:
		
		module.initialize(context)
	
	if _started:
	    return

	app = context._ProductContext__app
	
	if hasattr(app, 'ScheduleList'):
		scheduleList = getattr(app, 'ScheduleList')
		for schedilePath in scheduleList.getList():
			schedule = app.unrestrictedTraverse(schedilePath)
			schedule.ignoreLater()
			_threads.append( schedule.startDaemon( postpone=1 ) )

